#include "main.h"

int main(int argc, char **argv)
{
    char* buf = NULL;
    char* temp = NULL;
    int i = 0;
    int n = 0;
    int oldpoint = 0;
    int point = 0;
    int port = 0;
    int sock = 0;
    int timevalue = 0;
    short int maxclients = 0;
    short int maxpclients = 0;
    short int nofaliens = 0;
    short int nofpslots = 0;
    short int noffslots = 0;
    short int nofhumans = 0;
    short int nofspecs = 0;
    struct pldata* root = NULL;
    struct pldata* current = NULL;    
    struct pldata* created = NULL;
    struct timeval* tval = NULL;
    
    if(argc == 1)
    {
	fprintf(stdout, "Usage: <hostname> <(optional) port number>\n");
	return(0);
    }
    else if(argc == 2)
    {
	if((sock = connectsock(argv[1], "30720", "udp")) < 0) return(0);
	port = 30720;
    }
    else
    {
	if((sock = connectsock(argv[1], argv[2], "udp")) < 0) return(0);
	port = atoi(argv[2]);
    }
    buf = malloc(INPUTSIZE);
    memset(buf, 0, INPUTSIZE);
    tval = malloc(sizeof(struct timeval));
    i = write(sock, "\xFF\xFF\xFF\xFFgetstatus", 25);
    n = gettimeofday(tval, NULL);
    timevalue = (int)tval->tv_usec;
    i = read(sock, buf, INPUTSIZE);
    n = gettimeofday(tval, NULL);
    if(shutdown(sock, SHUT_RDWR) < 0)
    {
	fprintf(stderr, "Error closing connection: %s\n", strerror(errno));
	free(buf);
	free(tval);
	return(-1);
    }
    if(i > 0)
    {
	if((n = bruteforce(buf, "statusResponse\n")) > 0)
	{
	    fprintf(stdout, "Connection established with --- %s:%d\n", argv[1], port);
	    if((timevalue = (int)((tval->tv_usec - timevalue) / 1000)) < 0) timevalue = 1000 - timevalue;
	    if(timevalue > 1000) timevalue = 2000 - timevalue;
	    fprintf(stdout, "\tHost response size ---- %d bytes\n", i);
	    fprintf(stdout, "\tHost response time ---- %d miliseconds\n\n", timevalue);
	    *(buf + n) = ':';
	}
	else
	i = 0;
    }
    free(tval);
    if(i <= 0)
    {
	fprintf(stdout, "Failed to connect with -------- %s:%d\n\n", argv[1], port);
	return(1);
    }
    temp = malloc(OUTPUTSIZE);
    if(!getvar(buf, temp, "sv_hostname"))
    {
	fprintf(stdout, "Server name ------------------- ");
	i = 0;
	while(i < strlen(temp))
	{
	    if(*(temp + i) == '^') i++;
	    else fprintf(stdout, "%c", *(temp + i));
	    i++;
	}
	fprintf(stdout, "\n");
    }
    if(!getvar(buf, temp, "version")) fprintf(stdout, "\tServer version -------- %s\n", temp);
    if(!getvar(buf, temp, "protocol")) fprintf(stdout, "\tProtocol -------------- %s\n", temp);
    if(!getvar(buf, temp, "gamename")) fprintf(stdout, "\tGame mod -------------- %s\n", temp);
    if(!getvar(buf, temp, "sv_minPing")) fprintf(stdout, "\tMinimal ping ---------- %s\n", temp);
    if(!getvar(buf, temp, "sv_maxPing")) fprintf(stdout, "\tMaximal ping ---------- %s\n", temp);
    if(!getvar(buf, temp, "sv_minRate")) fprintf(stdout, "\tMinimal network rate -- %s\n", temp);
    if(!getvar(buf, temp, "sv_maxRate")) fprintf(stdout, "\tMaximal network rate -- %s\n", temp);
    if(!getvar(buf, temp, "sv_allowDownload")) fprintf(stdout, "\tDownloading allowed --- %s\n", temp);
    if(!getvar(buf, temp, "g_needpass")) fprintf(stdout, "\tPassword needed ------- %s\n", temp);
    fprintf(stdout, "\n");
    if(!getvar(buf, temp, "mapname")) fprintf(stdout, "Current map name -------------- %s\n", temp);
    if(!getvar(buf, temp, "timelimit")) fprintf(stdout, "\tTimelimit ------------- %s\n", temp);
    if(!getvar(buf, temp, "g_suddenDeathTime")) fprintf(stdout, "\tSuddenDeath time ------ %s\n", temp);
    if(!getvar(buf, temp, "sv_maxclients")) maxclients = atoi(temp);
    if(!getvar(buf, temp, "sv_privateClients")) maxpclients = atoi(temp);
    if((n = bruteforce(buf, "P\\")) > 0)
    {
	root = malloc(sizeof(struct pldata));
	root->slot = 0;
	if(maxpclients != 0) root->priv = 1; else root->priv = 0;
	root->type = convert(*(buf + n + 1));
	root->next = NULL;
	switch(root->type)
	{
	    case -1: { if(root->priv == 0) noffslots++; break; }
	    case 0: { if(root->priv == 1) nofpslots++; nofspecs++; break; }
	    case 1: { if(root->priv == 1) nofpslots++; nofaliens++; break; }
	    case 2: { if(root->priv == 1) nofpslots++; nofhumans++; break; }
	}
	current = root;
	for(i = 1; i < maxclients; i++)
	{
	    created = malloc(sizeof(struct pldata));
	    created->slot = i;
	    if(i < maxpclients) created->priv = 1; else created->priv = 0;
	    created->type = convert(*(buf + n + i + 1));
	    created->next = NULL;
	    switch(created->type)
	    {
		case -1: { if(created->priv == 0) noffslots++; break; }
		case 0: { if(created->priv == 1) nofpslots++; nofspecs++; break; }
		case 1:	{ if(created->priv == 1) nofpslots++; nofaliens++; break; }
		case 2:	{ if(created->priv == 1) nofpslots++; nofhumans++; break; }
	    }
	    current->next = created;
	    current = current->next;
	}
	fprintf(stdout, "\nSlots ------------------------- %d\t(%d)\nTotal ------------------------- %d\t(%d)\n", 
	nofspecs + nofaliens + nofhumans - nofpslots, nofpslots, maxclients - maxpclients, maxpclients);
	fprintf(stdout, "\tAlien players --------- %d\n", nofaliens);
	fprintf(stdout, "\tHuman players --------- %d\n", nofhumans);
	fprintf(stdout, "\tSpectators ------------ %d\n", nofspecs);
	fprintf(stdout, "\tFree slots ------------ %d\n", maxclients - maxpclients - nofspecs - nofaliens - nofhumans + nofpslots);
	fprintf(stdout, "\nSlot\tFrags\tPing\tTeam\tPlayer name\n");
	if((n = bruteforce(buf, "\n")) > 0)
	{
	    i = 0;
	    point = n;
	    oldpoint = n;
	    while(i != nofspecs + nofaliens + nofhumans)
	    {
		point = getplayerstats(buf, temp, root, oldpoint, i);
		oldpoint = point;
		i++;
	    }
	}
    }
    else
    {
	fprintf(stdout, "\nSlots ------------------------- N/A (N/A)\nTotal ------------------------- %d (N/A)\n", maxclients);
	fprintf(stdout, "\tAlien players --------- N/A\n");
	fprintf(stdout, "\tHuman players --------- N/A\n");
	fprintf(stdout, "\tSpectators ------------ N/A\n");
	fprintf(stdout, "\tFree slots ------------ N/A\n");
	fprintf(stdout, "\nSlot\tFrags\tPing\tTeam\tPlayer name\n");
	if((n = bruteforce(buf, "\n")) > 0)
	{
	    i = 0;
	    point = n;
	    oldpoint = n;
	    while(oldpoint + 1 < strlen(buf))
	    {
		fprintf(stdout, "%d\t", i);
		point = getplayerstats(buf, temp, NULL, oldpoint, -1);
		oldpoint = point;
		i++;
	    }
	}
    }
    free(buf);
    free(temp);
    return(0);
}
