#include <errno.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>

#ifdef WIN32
    #include <windows.h>
    #include <winsock.h>
#else
    #include <arpa/inet.h>
    #include <netinet/in.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <sys/time.h>
#endif

#define INPUTSIZE 10000
#define OUTPUTSIZE 100

struct pldata
{
    short int priv;
    short int slot;
    short int type;
    struct pldata* next;
};

int connectsock(char*, char*, char*);
int bruteforce(char*, char*);
short int getvar(char*, char*, char*);
short int convert(char);
int getplayerstats(char*, char*, struct pldata*, int, int);
